# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

from azdata.cli.core.i18n import translate
from azdata.cli.core.commands import CliCommandsLoader
from azdata.cli.commands.extension.command_table import load_command_table

_ = translate('azdata.cli.commands.extension')

__all__ = ['_', 'COMMAND_LOADER_CLS']


class ExtensionCommandsLoader(CliCommandsLoader):

    def __init__(self, cli_ctx=None):
        import azdata.cli.commands.extension.help  # pylint: disable=W0611,C0413
        super(ExtensionCommandsLoader, self).__init__(cli_ctx=cli_ctx)

    def load_command_table(self, args):
        load_command_table(self, args)
        return self.command_table

    def load_arguments(self, command):
        from azdata.cli.commands.extension.arguments import load_arguments
        load_arguments(self, command)


COMMAND_LOADER_CLS = ExtensionCommandsLoader
