# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------

from knack.commands import CommandGroup
from azdata.cli.commands.hdfs import client


def load_command_table(self, _):
    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('shell', 'hdfs_shell')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('ls', 'hdfs_ls')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('exists', 'hdfs_exists')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('mkdir', 'hdfs_mkdir')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('mv', 'hdfs_mv')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('create', 'hdfs_create')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('cat', 'hdfs_cat')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('rm', 'hdfs_rm')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('rmr', 'hdfs_rmr')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('chmod', 'hdfs_chmod')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('chown', 'hdfs_chown')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('acl modify', 'hdfs_acl_modify')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('acl remove', 'hdfs_acl_remove')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('acl set', 'hdfs_acl_set')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('acl status', 'hdfs_acl_status')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('xattr get', 'hdfs_xattr_get')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('xattr set', 'hdfs_xattr_set')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('xattr modify', 'hdfs_xattr_modify')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('xattr remove', 'hdfs_xattr_remove')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('xattr status', 'hdfs_xattr_status')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('cp', 'hdfs_cp')

    with CommandGroup(self, 'bdc hdfs', 'azdata.cli.commands.hdfs.custom#{}',
                      client_factory=client.beget) as g:
        g.command('mount create', 'hdfs_mount_create')
        g.command('mount delete', 'hdfs_mount_delete')
        g.command('mount status', 'hdfs_mount_status')
        g.command('mount refresh', 'hdfs_mount_refresh')
