# ------------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# ------------------------------------------------------------------------------


from azdata.cli.core.exceptions import CliError


class HdfsError(CliError):
    """All errors related to hdfs API calls."""
    pass


class PyWebHdfsException(Exception):
    def __init__(self, msg=str()):
        self.msg = msg
        super(PyWebHdfsException, self).__init__(self.msg)


class BadRequest(PyWebHdfsException):
    pass


class Unauthorized(PyWebHdfsException):
    pass


class FileNotFound(PyWebHdfsException):
    pass


class MethodNotAllowed(PyWebHdfsException):
    pass


class ActiveHostNotFound(PyWebHdfsException):
    pass


class CorrespondHostsNotFound(PyWebHdfsException):
    pass

